<template>
    <div class="p-3">
        <section>
            <h2 class="">Welcome {{ stats.publisher_name }}</h2>

            <div class="card p-3 bg-secondary text-white">
                <h4 class="card-title">Content Performance Summary</h4>
                <div class="card-body row">
                    <div class="col-3">
                        <span class="h3">{{ stats.views }}</span>
                        <br>Impressions
                    </div>

                    <div class="col-3">
                        <span class="h3">{{ stats.clicks }}</span>
                        <br>Clicks
                    </div>

                    <div class="col-3">
                        <span class="h3">{{ Number((stats.clicks / stats.views) * 100).toFixed(2) }} %</span>
                        <br>CTR
                    </div>

                    <div class="col-3">
                        <span class="h3">Br {{ Number((stats.views * 0.5) + (stats.clicks * 1.5)).toFixed(2) }}</span>
                        <br>Cost
                    </div>
                </div>
            </div>
        </section>

        <hr>

        <section class="mt-2">

            <h3>About Your Contents</h3>

            <div class="row mx-auto">

                <div class="col-md-4 p-1">
                    <div class="card bg-transparent " style="min-height: 8rem;">
                        <div class="card-header">
                            <span class="font-weight-bold">Most Impressions</span>
                        </div>

                        <ul class="list-group list-group-flush" v-for="viewedContent in stats.most_viewed">
                            <router-link :to="'/publisher/my-contents/' + viewedContent.content.id" class="list-group-item list-group-item-action">{{ viewedContent.content.name }} <span class="float-right">{{viewedContent.views}}</span></router-link>
                        </ul>

                        <div class="card-footer bg-transparent">
                            <router-link to="/publisher/my-contents" class="card-link float-right">View All</router-link>
                        </div>

                    </div>
                </div>

                <div class="col-md-4 p-1">
                    <div class="card bg-transparent " style="min-height: 8rem;">
                        <div class="card-header">
                            <span class="font-weight-bold">Most Clicks</span>
                        </div>

                        <ul class="list-group list-group-flush" v-for="clickedContent in stats.most_clicked">
                            <router-link :to="'/publisher/my-contents/' + clickedContent.content.id" class="list-group-item list-group-item-action">{{ clickedContent.content.name }} <span class="float-right">{{clickedContent.clicks}}</span></router-link>
                        </ul>

                        <div class="card-footer bg-transparent">
                            <router-link to="/publisher/my-contents" class="card-link float-right">View All</router-link>
                        </div>

                    </div>
                </div>

            </div>

        </section>

    </div>
</template>

<script>
    export default {
        data: function () {
            return {
                stats: null,

                // Loading flag
                loading: false,

                // Status Flags
                fail: false,
                success: false,
            }
        },
        methods: {
            loadStats: function () {
                // Show the loading
                this.loading = true;

                // Clear previous flags
                this.success = false;
                this.fail = false;

                // Make a request to the API
                axios.get('/api/publisher')
                    .then(response => {
                        this.stats = response.data;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 401) {
                                this.fail = {
                                    'message': 'Unauthorized'
                                };
                            } else {
                                this.fail = {
                                    message: 'Something Went Wrong. Check your connection and try again.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Publisher - Home mounted.');

            // Load the stats
            this.loadStats();
        }
    }
</script>
